-- BLOBBY-VOLLEY-SPIEL-KONSTANTEN:

FIELD_WIDTH 	= 800
BALL_RADIUS 	= 31.5
GROUND_PLANE 	= 100
BLOBBY_HEIGHT 	= 89
BLOBBY_MAXJUMP 	= 393.625
NETZ_HEIGHT 	= 323
NETZ_RADIUS		= 7
GRAVITY 		= 0.28
TOLERANZ 		= 4.5		-- Toleranzwert, fr die Bewegung des Blobbys in der Horizontalen

-- EIGENE KONSTANTEN (knnen gendert werden):

STANDARD_POS 	= 200
MIN_ANGRIFF		= 35
MAX_ANGRIFF 	= 55


-- VARIABLEN (bitte NICHT ndern)

myServe		 = 999	-- Versetzung zum Ball bei der Angabe
Angriffsversetzung = 999	-- Versetzung zum Ball beim Springen
OldPosX		 = 999	-- alte X-Koodinate, wichtig bei Sprung

-- SPIEL-FUNKTIONEN:

function OnOpponentServe()					-- bei gegnerischer Angabe:
	move(STANDARD_POS)					-- zur Standardposition gehen!
end

function OnServe(ballready)
	if (myServe == 999) then				-- wenn noch keine Versetzung
		myServe = math.random(150,180)		-- fr die Angabe bestimmt wurde:
	end
	
	move(myServe)						-- zur Position bewegen
	
	if ballready and math.abs(posx()-myServe) < TOLERANZ then 
		jump()						-- Angabe ausfhren
		myServe = 999					-- Variable zurcksetzen
	end
end

function OnGame()
	if bspeedx()>0 then
		if Angriffsversetzung>40 then
			Angriffsversetzung = 40
		end
	end
	-- Verschiedene Flle, in denen ein Sprung mglich/vorteilhaft ist:

	if math.abs(ballx()-posx()) < 4*BALL_RADIUS		
	   and bally() < 650 and bally() > NETZ_HEIGHT
	   and bspeedy()<2
	   and math.abs(bspeedx())<7 then

		jump()
		move(ballx() - Angriffsversetzung)

	elseif posx() > 325 and ballx() > 325			-- dient zur Rettung von sog. Netzrollern
		 and math.abs(ballx() - posx()) < bspeedx()*5
		 and bally() < 400 and bally() > 280 then 

		jump()	
		move(ballx())
	
	elseif posy() < bally()-BALL_RADIUS				-- Angreifen, wenn der Ball nicht von der Wand abspringt
		 and estimateY(posx()) > 350
		 and estimateY(posx()) < 450
		 and estimateX(GROUND_PLANE + BLOBBY_MAXJUMP) < 400
		 and ballx()-posx() < bspeedx()^2.5 then

		if OldPosX == 999 then 
			OldPosX = posx()
		end

		jump()
		move(OldPosX-Angriffsversetzung)
	
	else									-- Ansonsten zum geplanten Einschlagspunkt laufen:					

		Angriffsversetzung = math.random(MIN_ANGRIFF, MAX_ANGRIFF)	
		OldPosX = 999

		myEstimateX = estimateX(BLOBBY_HEIGHT + GROUND_PLANE + BALL_RADIUS)

		if ballx() < 500 then
			move(myEstimateX)
		else
			move(STANDARD_POS)
		end
	end
end


function estimateX(onY) 
	if (bspeedy() == 0) and (bspeedx() == 0) then
		return ballx()
	end
	
	time =(-bspeedy()-math.sqrt((bspeedy()^2)-(-2*GRAVITY *(bally()-onY))))/(-GRAVITY)
	estimatedX = (bspeedx() * time) + ballx()

	if(estimatedX > 393-BALL_RADIUS) then
		estimatedX = 400
	end

	if(estimatedX < BALL_RADIUS) then
		estimatedX = 2 * BALL_RADIUS - estimatedX
	end

	return estimatedX
end

function estimateY(onX)
	if (bspeedx() == 0) then
		time = 0
	else
		time=(onX-ballx())/bspeedx()
	end
	y=1/2*(-GRAVITY)*time^2 + bspeedy()*time + bally()
 	return y
end

function move(toX)
	if math.abs(posx()-toX) >= TOLERANZ then
		if posx()-toX > 0 then
			left()
		else
			right()
		end
	end
end
